org.apache.commons.collections4

## Interface BidiMap<K,V>

- Type Parameters:
    `K` - the type of the keys in the map
    `V` - the type of the values in the map
  All Superinterfaces:
    Get<K,V>, IterableGet<K,V>, IterableMap<K,V>, Map<K,V>, Put<K,V>
  All Known Subinterfaces:
    OrderedBidiMap<K,V>, SortedBidiMap<K,V>
  All Known Implementing Classes:
    AbstractBidiMapDecorator, AbstractDualBidiMap, AbstractOrderedBidiMapDecorator, AbstractSortedBidiMapDecorator, DualHashBidiMap, DualLinkedHashBidiMap, DualTreeBidiMap, TreeBidiMap, UnmodifiableBidiMap, UnmodifiableOrderedBidiMap, UnmodifiableSortedBidiMap

      public interface BidiMap<K,V>
      extends IterableMap<K,V>

  Defines a map that allows bidirectional lookup between key and values.

  This extended `Map` represents a mapping where a key may lookup a value and a value may lookup a key with equal ease. This interface extends `Map` and so may be used anywhere a map is required. The interface provides an inverse map view, enabling full access to both directions of the `BidiMap`.

  Implementations should allow a value to be looked up from a key and a key to be looked up from a value with equal performance.

  This map enforces the restriction that there is a 1:1 relation between keys and values, meaning that multiple keys cannot map to the same value. This is required so that "inverting" the map results in a map without duplicate keys. See the `put(K, V)` method description for more information.

  Since:
    3.0

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface java.util.Map

      `Map.Entry<K,V>`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `K` | `getKey(Object value)` Gets the key that is currently mapped to the specified value.
    `BidiMap<V,K>` | `inverseBidiMap()` Gets a view of this map where the keys and values are reversed.
    `V` | `put(K key, V value)` Puts the key-value pair into the map, replacing any previous pair.
    `K` | `removeValue(Object value)` Removes the key-value pair that is currently mapped to the specified value (optional operation).
    `Set<V>` | `values()` Returns a `Set` view of the values contained in this map.

    - ### Methods inherited from interface java.util.Map

      `clear, compute, computeIfAbsent, computeIfPresent, containsKey, containsValue, entrySet, equals, forEach, get, getOrDefault, hashCode, isEmpty, keySet, merge, putAll, putIfAbsent, remove, remove, replace, replace, replaceAll, size`

    - ### Methods inherited from interface org.apache.commons.collections4.Put

      `clear, putAll`

    - ### Methods inherited from interface org.apache.commons.collections4.IterableGet

      `mapIterator`

    - ### Methods inherited from interface org.apache.commons.collections4.Get

      `containsKey, containsValue, entrySet, get, isEmpty, keySet, remove, size`

- - ### Method Detail

    - #### put

          V put(K key,
                V value)

      Puts the key-value pair into the map, replacing any previous pair.

      When adding a key-value pair, the value may already exist in the map against a different key. That mapping is removed, to ensure that the value only occurs once in the inverse map.

            BidiMap map1 = new DualHashBidiMap();
            map.put("A","B");  // contains A mapped to B, as per Map
            map.put("A","C");  // contains A mapped to C, as per Map

            BidiMap map2 = new DualHashBidiMap();
            map.put("A","B");  // contains A mapped to B, as per Map
            map.put("C","B");  // contains C mapped to B, key A is removed

      Specified by:
        `put` in interface `Map<K,V>`
      Specified by:
        `put` in interface `Put<K,V>`
      Parameters:
        `key` - the key to store
        `value` - the value to store
      Returns:
        the previous value mapped to this key
      Throws:
        `UnsupportedOperationException` - if the `put` method is not supported
        `ClassCastException` - (optional) if the map limits the type of the value and the specified value is inappropriate
        `IllegalArgumentException` - (optional) if the map limits the values in some way and the value was invalid
        `NullPointerException` - (optional) if the map limits the values to non-null and null was specified
      See Also:
        `Map.put(Object, Object)`

    - #### getKey

          K getKey(Object value)

      Gets the key that is currently mapped to the specified value.

      If the value is not contained in the map, `null` is returned.

      Implementations should seek to make this method perform equally as well as `get(Object)`.

      Parameters:
        `value` - the value to find the key for
      Returns:
        the mapped key, or `null` if not found
      Throws:
        `ClassCastException` - (optional) if the map limits the type of the value and the specified value is inappropriate
        `NullPointerException` - (optional) if the map limits the values to non-null and null was specified

    - #### removeValue

          K removeValue(Object value)

      Removes the key-value pair that is currently mapped to the specified value (optional operation).

      If the value is not contained in the map, `null` is returned.

      Implementations should seek to make this method perform equally as well as `remove(Object)`.

      Parameters:
        `value` - the value to find the key-value pair for
      Returns:
        the key that was removed, `null` if nothing removed
      Throws:
        `ClassCastException` - (optional) if the map limits the type of the value and the specified value is inappropriate
        `NullPointerException` - (optional) if the map limits the values to non-null and null was specified
        `UnsupportedOperationException` - if this method is not supported by the implementation

    - #### inverseBidiMap

          BidiMap<V,K> inverseBidiMap()

      Gets a view of this map where the keys and values are reversed.

      Changes to one map will be visible in the other and vice versa. This enables both directions of the map to be accessed as a `Map`.

      Implementations should seek to avoid creating a new object every time this method is called. See `AbstractMap.values()` etc. Calling this method on the inverse map should return the original.

      Returns:
        an inverted bidirectional map

    - #### values

          Set<V> values()

      Returns a `Set` view of the values contained in this map. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress (except through the iterator's own `remove` operation), the results of the iteration are undefined. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll` and `clear` operations. It does not support the `add` or `addAll` operations.
      Specified by:
        `values` in interface `Get<K,V>`
      Specified by:
        `values` in interface `Map<K,V>`
      Returns:
        a set view of the values contained in this map
      See Also:
        `Map.values()`

Copyright © 2001–2019 The Apache Software Foundation. All rights reserved.